@warnings
@version 0.6

main
{
    fontsLoaded = fontcount();

    if(!fontsLoaded)
    {
        if((fontName = getfile("Select a Font","*.*",getdir("Fonts"))) == nil)
            return;
    }

    for(x = 1;x <= fontsLoaded;x++)
        fontList[x] = fontname(x);
	
	
	
	logo_text = "Text";
    select_font = 1;
    chars_layers = false;
    Extrude = false;
    extrude_extent = 0.2;
    Bevel = false;
    bevel_shift = 0.01;
    bevel_inset = 0.01;
    Shape_bevel = false;
    shape_shift_1 = 0.01;
    shape_inset_1 = 0.01;
    shape_shift_2 = 0.01;
    shape_inset_2 = 0.01;

    reqbegin("Logo++");
    reqsize(229,439);

    c1 = ctlstring("Logo Text",logo_text);
    ctlposition(c1,9,9,213,21,60);

    if(fontList && !fontName)
		c2 = ctlpopup("Select Font",1,fontList);
    ctlposition(c2,9,39,213,21,60);
	
	s1 = ctlsep(10,213);
    ctlposition(s1,9,69);
	
    c3 = ctlcheckbox("Chars * Layers",chars_layers);
    ctlposition(c3,9,79,150,21);
	
	s2 = ctlsep(10,213);
    ctlposition(s2,9,109);
	
    c4 = ctlcheckbox("Extrude",Extrude);
    ctlposition(c4,9,119,150,21);

    c5 = ctldistance("Extent",extrude_extent);
    ctlposition(c5,29,149,130,21,40);
	ctlactive(c4, "toggleOn", c5);
	
	s3 = ctlsep(10,213);
    ctlposition(s3,9,179);

    c6 = ctlcheckbox("Bevel",Bevel);
    ctlposition(c6,9,189,150,21);

    c7 = ctldistance("Shift",bevel_shift);
    ctlposition(c7,29,219,130,21,40);
	ctlactive(c6, "toggleOn", c7);

    c8 = ctldistance("Inset",bevel_inset);
    ctlposition(c8,29,241,130,21,40);
	ctlactive(c6, "toggleOn", c8);
	
	s4 = ctlsep(10,213);
    ctlposition(s4,9,271);

    c9 = ctlcheckbox("Shape Bevel",Shape_bevel);
    ctlposition(c9,9,281,150,21);

    c10 = ctldistance("Shift 1",shape_shift_1);
    ctlposition(c10,29,311,130,21,40);
	ctlactive(c9, "toggleOn", c10);

    c11 = ctldistance("Inset 1",shape_inset_1);
    ctlposition(c11,29,333,130,21,40);
	ctlactive(c9, "toggleOn", c11);

    c12 = ctldistance("Shift 2",shape_shift_2);
    ctlposition(c12,29,355,130,21,40);
	ctlactive(c9, "toggleOn", c12);

    c13 = ctldistance("Inset 2",shape_inset_2);
    ctlposition(c13,29,377,130,21,40);
	ctlactive(c9, "toggleOn", c13);

    return if !reqpost();

    logo_text = getvalue(c1);
    select_font = getvalue(c2);
    chars_layers = getvalue(c3);
    Extrude = getvalue(c4);
    extrude_extent = getvalue(c5);
    Bevel = getvalue(c6);
    bevel_shift = getvalue(c7);
    bevel_inset = getvalue(c8);
    Shape_bevel = getvalue(c9);
    shape_shift_1 = getvalue(c10);
    shape_inset_1 = getvalue(c11);
    shape_shift_2 = getvalue(c12);
    shape_inset_2 = getvalue(c13);
	
	if(fontList && !fontName)
        findex = getvalue(c2);
    else
        findex = fontload(fontName);
	
    reqend();
	
//---------------------------------
	number_chars = logoText.size();
	
	selmode(USER);
	
	if(chars_layers==0)
	{
		maketext(logo_text,findex);
		
		if(Extrude!=0)
		{
			extrude(Z,extrude_extent);
		}
		
		if(Bevel!=0)
		{
			numPolys = polycount();
			numPolysMin = numPolys[5];
			numPolysSlc = numPolys[6];
		
			for(i=1; i<=numPolysSlc; i++)
			{
				editbegin();
					polyArray = polygons;
					number_set = (numPolysMin ) + i;
					onePolyID = polyArray[number_set];
				editend();
			
				selpolygon(SET, POLYID, onePolyID);
				
				bevel(bevel_shift,bevel_inset);
				
				selpolygon(CLEAR);
			}
		}
		
		if(Shape_bevel!=0)
		{
			numPolys = polycount();
			numPolysMin = numPolys[5];
			numPolysSlc = numPolys[6];
		
			for(i=1; i<=numPolysSlc; i++)
			{
				editbegin();
					polyArray = polygons;
					number_set = (numPolysMin ) + i;
					onePolyID = polyArray[number_set];
				editend();
			
				selpolygon(SET, POLYID, onePolyID);
				
				s = string(shape_shift_1," ",shape_inset_1," ",shape_shift_2," ",shape_inset_2 / 2);
				shapebevel(s);
				
				selpolygon(CLEAR);
			}
		}
		
		
	}
	else
	{
		number_chart = logo_text.size(); 
	
		layer_pos = 1;
		layer_pos = layer_pos - 1;
		actionPos = 0;

		for(x=1; x<=number_chart; x++)
		{
			layer_number = (layer_pos + x);
			
			lyrsetfg(layer_number);
			
			maketext(logo_text[x],findex);
			
			if(Extrude!=0)
			{
				extrude(Z,extrude_extent);
			}
		
			if(Bevel!=0)
			{
				numPolys = polycount();
				numPolysMin = numPolys[5];
				numPolysSlc = numPolys[6];
		
				for(i=1; i<=numPolysSlc; i++)
				{
					editbegin();
						polyArray = polygons;
						number_set = (numPolysMin ) + i;
						onePolyID = polyArray[number_set];
					editend();
			
					selpolygon(SET, POLYID, onePolyID);
				
					bevel(bevel_shift,bevel_inset);
				
					selpolygon(CLEAR);
				}
			}
		
			if(Shape_bevel!=0)
			{
				numPolys = polycount();
				numPolysMin = numPolys[5];
				numPolysSlc = numPolys[6];
		
				for(i=1; i<=numPolysSlc; i++)
				{
					editbegin();
						polyArray = polygons;
						number_set = (numPolysMin ) + i;
						onePolyID = polyArray[number_set];
					editend();
			
					selpolygon(SET, POLYID, onePolyID);
				
					s = string(shape_shift_1," ",shape_inset_1," ",shape_shift_2," ",shape_inset_2 / 2);
					shapebevel(s);
				
					selpolygon(CLEAR);
				}
			}

			if(x!=1)
			{
				(loBound,hiBound) = boundingbox(layer_number - 1);
			
				actionSize  = hiBound.x - loBound.x ;
				actionPos	+= actionSize+0.2;
			
				move(actionPos,0,0);
			}
		}
	}
	
		
	if(!fontsLoaded && fontName)
		fontclear(findex);	
	
	
}

toggleOn: value
{
   return(value);
}

